import { Config } from '@stencil/core/internal';
import type { PackageJSON } from './types';
export declare const toLowerCase: (str: string) => string;
export declare const dashToPascalCase: (str: string) => string;
export declare function sortBy<T>(array: T[], prop: (item: T) => string): T[];
export declare function normalizePath(str: string): string;
export declare function relativeImport(pathFrom: string, pathTo: string, ext?: string): string;
export declare function isRelativePath(path: string): boolean | "";
export declare function readPackageJson(config: Config, rootDir: string): Promise<PackageJSON>;
/**
 * Returns the formatted custom event interface name for the component.
 * With a tag of "my-cmp", it will return "MyCmpCustomEvent".
 *
 * @param componentTagName The tag selector of the component (i.e. my-cmp)
 * @returns The formatted custom event interface name.
 */
export declare function formatCustomEventInterfaceName(componentTagName: string): string;
